HDU 1535 Invitation Cards(逆向思维+邻接表+优先队列的Dijkstra算法)

时间:2023-06-22 13:20:44

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=1535

Problem Description
In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have printed invitation cards with all the necessary information and with the programme. A lot of students were hired to distribute these invitations among the people. Each student volunteer has assigned exactly one bus stop and he or she stays there the whole day and gives invitation to people travelling by bus. A special course was taken where students learned how to influence people and what is the difference between influencing and robbery.
The transport system is very special: all
lines are unidirectional and connect exactly two stops. Buses leave the
originating stop with passangers each half an hour. After reaching the
destination stop they return empty to the originating stop, where they
wait until the next full half an hour, e.g. X:00 or X:30, where 'X'
denotes the hour. The fee for transport between two stops is given by
special tables and is payable on the spot. The lines are planned in such
a way, that each round trip (i.e. a journey starting and finishing at
the same stop) passes through a Central Checkpoint Stop (CCS) where each
passenger has to pass a thorough check including body scan.

All
the ACM student members leave the CCS each morning. Each volunteer is
to move to one predetermined stop to invite passengers. There are as
many volunteers as stops. At the end of the day, all students travel
back to CCS. You are to write a computer program that helps ACM to
minimize the amount of money to pay every day for the transport of their
employees.

Input
The
input consists of N cases. The first line of the input contains only
positive integer N. Then follow the cases. Each case begins with a line
containing exactly two integers P and Q, 1 <= P,Q <= 1000000. P is
the number of stops including CCS and Q the number of bus lines. Then
there are Q lines, each describing one bus line. Each of the lines
contains exactly three numbers - the originating stop, the destination
stop and the price. The CCS is designated by number 1. Prices are
positive integers the sum of which is smaller than 1000000000. You can
also assume it is always possible to get from any stop to any other
stop.
Output
For
each case, print one line containing the minimum amount of money to be
paid each day by ACM for the travel costs of its volunteers.
Sample Input
2
2 2
1 2 13
2 1 33
4 6
1 2 10
2 1 60
1 3 20
3 4 10
2 4 5
4 1 50
Sample Output
46
210
 /*
问题
输入顶点数p和边数q以及q条边
计算并输出顶点1到每个顶点的最短路径花费,再加上每个顶点到1的最短路径花费 解题思路
求1号顶点到其余顶点的最短路径之和不难,Dijkstra求解单源最短路即可,关键是其余顶点到1号顶点的最短路径之和
具体做法是将原图的所有边都反向存储一遍,再跑一边1号顶点到其余顶点的Dijkstra单源最短路就是要求的其余顶点到1号顶
点的最短路径之和。
另外由于顶点和边很多,所以采用邻接表+优先队列优化的Dijkstra算法。
*/
#include<bits/stdc++.h>//HDU G++
const int maxn=1e6+;
const int INF=1e9+; using namespace std; int u[maxn],v[maxn],w[maxn]; struct Edge{
int from,to,dist;
}; struct HeapNode{
int d,u;
bool operator < (const HeapNode& rhs) const {//优先队列,重载<运算符
return d >rhs.d;
}
}; struct Dijkstra{
int n,m;
vector<Edge> edges; //邻接表
vector<int> G[maxn]; //每个节点出发的边编号(从0开始编号)
bool done[maxn]; //是否已经永久编号
int d[maxn]; //s到各个点的距离
int p[maxn]; //最短路中的上一条边 void init(int n){
this->n =n;
for(int i=;i<n;i++) G[i].clear();//清空邻接表
edges.clear(); //清空边表
} void AddEdge(int from,int to,int dist){
//如果是无向图需要将每条无向边存储两边,及调用两次AddEdge
edges.push_back((Edge){from,to,dist});
m=edges.size();
G[from].push_back(m-);
} void dijkstra(int s){//求s到其他点的距离
priority_queue<HeapNode> Q;
for(int i=;i<n;i++) d[i]=INF;
d[s]=; memset(done,,sizeof(done));
Q.push((HeapNode){,s}); while(!Q.empty()){
HeapNode x =Q.top();
Q.pop(); int u=x.u;
if(done[u]) continue;
done[u]=true; for(int i=;i<G[u].size();i++){
Edge& e = edges[G[u][i]];
if(d[e.to] > d[u] + e.dist){
d[e.to] = d[u] + e.dist;
p[e.to] = G[u][i];
Q.push((HeapNode){d[e.to],e.to});
}
}
}
}
}; struct Dijkstra solver; int main()
{
int T,n,m;
scanf("%d",&T);
while(T--){
scanf("%d%d",&n,&m);
solver.init(n);
for(int i=;i<=m;i++){
scanf("%d%d%d",&u[i],&v[i],&w[i]);
u[i]--;//模板中的顶点从0开始
v[i]--;
solver.AddEdge(u[i],v[i],w[i]);
}
solver.dijkstra();
int ans=;
for(int i=;i<solver.n;i++)
ans += solver.d[i]; solver.init(n);
for(int i=;i<=m;i++){
solver.AddEdge(v[i],u[i],w[i]);//清空后反向存储
}
solver.dijkstra();
for(int i=;i<solver.n;i++)
ans += solver.d[i]; printf("%d\n",ans);
}
return ;
}